From 94f1df539e46373821665f4f229bb485d34d98e8 Mon Sep 17 00:00:00 2001
From: Maxim Orlov <orlovmg@gmail.com>
Date: Fri, 23 May 2025 09:07:55 +0300
Subject: [PATCH v63 8/8] Use PRI?64 instead of ll? in XID format

---
 contrib/amcheck/verify_heapam.c               | 138 +++++++++---------
 contrib/pageinspect/btreefuncs.c              |   4 +-
 contrib/pg_overexplain/pg_overexplain.c       |   2 +-
 contrib/pgrowlocks/pgrowlocks.c               |   9 +-
 contrib/test_decoding/test_decoding.c         |  38 ++---
 doc/src/sgml/logicaldecoding.sgml             |   2 +-
 src/backend/access/common/reloptions.c        |   7 +-
 src/backend/access/heap/heapam.c              |  90 +++++-------
 src/backend/access/heap/heapam_handler.c      |   4 +-
 src/backend/access/heap/vacuumlazy.c          |  18 +--
 src/backend/access/rmgrdesc/clogdesc.c        |   4 +-
 src/backend/access/rmgrdesc/committsdesc.c    |   4 +-
 src/backend/access/rmgrdesc/gistdesc.c        |  12 +-
 src/backend/access/rmgrdesc/hashdesc.c        |   4 +-
 src/backend/access/rmgrdesc/heapdesc.c        |  50 +++----
 src/backend/access/rmgrdesc/mxactdesc.c       |  15 +-
 src/backend/access/rmgrdesc/nbtdesc.c         |  12 +-
 src/backend/access/rmgrdesc/spgdesc.c         |   4 +-
 src/backend/access/rmgrdesc/standbydesc.c     |  17 +--
 src/backend/access/rmgrdesc/xactdesc.c        |  10 +-
 src/backend/access/rmgrdesc/xlogdesc.c        |  24 +--
 src/backend/access/transam/commit_ts.c        |   4 +-
 src/backend/access/transam/multixact.c        | 131 ++++++++---------
 src/backend/access/transam/slru.c             |  32 ++--
 src/backend/access/transam/subtrans.c         |   5 +-
 src/backend/access/transam/transam.c          |   8 +-
 src/backend/access/transam/twophase.c         |  54 ++++---
 src/backend/access/transam/xact.c             |  16 +-
 src/backend/access/transam/xlogrecovery.c     |  48 +++---
 src/backend/commands/vacuum.c                 |  10 +-
 src/backend/nodes/outfuncs.c                  |   2 +-
 .../replication/logical/applyparallelworker.c |   6 +-
 src/backend/replication/logical/conflict.c    |  44 +++---
 src/backend/replication/logical/logical.c     |   4 +-
 .../replication/logical/reorderbuffer.c       |  23 ++-
 src/backend/replication/logical/slotsync.c    |   6 +-
 src/backend/replication/logical/snapbuild.c   |  54 ++++---
 src/backend/replication/logical/worker.c      |  30 ++--
 src/backend/replication/pgoutput/pgoutput.c   |   4 +-
 src/backend/replication/slot.c                |   4 +-
 src/backend/replication/walreceiver.c         |   4 +-
 src/backend/replication/walsender.c           |   6 +-
 src/backend/storage/ipc/procarray.c           |  38 ++---
 src/backend/storage/ipc/standby.c             |  24 +--
 src/backend/storage/lmgr/lmgr.c               |   3 +-
 src/backend/storage/lmgr/predicate.c          |  12 +-
 src/backend/utils/adt/lockfuncs.c             |   3 +-
 src/backend/utils/adt/xid.c                   |   2 +-
 src/backend/utils/error/csvlog.c              |   6 +-
 src/backend/utils/error/elog.c                |  16 +-
 src/backend/utils/error/jsonlog.c             |   8 +-
 src/backend/utils/misc/guc.c                  |  36 +++--
 src/backend/utils/misc/guc_funcs.c            |   8 +-
 src/backend/utils/misc/help_config.c          |   8 +-
 src/backend/utils/misc/pg_controldata.c       |   4 +-
 src/backend/utils/time/snapmgr.c              |  29 ++--
 src/bin/initdb/initdb.c                       |  26 ++--
 src/bin/pg_controldata/pg_controldata.c       |  32 ++--
 src/bin/pg_dump/pg_dump.c                     |  31 ++--
 src/bin/pg_resetwal/pg_resetwal.c             |  80 +++++-----
 src/bin/pg_upgrade/pg_upgrade.c               |  46 +++---
 src/bin/pg_upgrade/segresize.c                |  10 +-
 src/bin/pg_waldump/pg_waldump.c               |   7 +-
 src/include/storage/bufpage.h                 |   5 +-
 .../modules/xid_wraparound/xid_wraparound.c   |  10 +-
 src/test/regress/regress.c                    |  15 +-
 66 files changed, 666 insertions(+), 756 deletions(-)

diff --git a/contrib/amcheck/verify_heapam.c b/contrib/amcheck/verify_heapam.c
index 4703e87c1e..f8460767b7 100644
--- a/contrib/amcheck/verify_heapam.c
+++ b/contrib/amcheck/verify_heapam.c
@@ -782,10 +782,10 @@ verify_heapam(PG_FUNCTION_ARGS)
 				TransactionIdIsInProgress(curr_xmin))
 			{
 				report_corruption(&ctx,
-								  psprintf("tuple with in-progress xmin %llu was updated to produce a tuple at offset %u with committed xmin %llu",
-										   (unsigned long long) curr_xmin,
+								  psprintf("tuple with in-progress xmin %" PRIu64 " was updated to produce a tuple at offset %u with committed xmin %" PRIu64,
+										   curr_xmin,
 										   (unsigned) ctx.offnum,
-										   (unsigned long long) next_xmin));
+										   next_xmin));
 			}
 
 			/*
@@ -798,16 +798,16 @@ verify_heapam(PG_FUNCTION_ARGS)
 			{
 				if (xmin_commit_status[nextoffnum] == XID_IN_PROGRESS)
 					report_corruption(&ctx,
-									  psprintf("tuple with aborted xmin %llu was updated to produce a tuple at offset %u with in-progress xmin %llu",
-											   (unsigned long long) curr_xmin,
+									  psprintf("tuple with aborted xmin %" PRIu64 " was updated to produce a tuple at offset %u with in-progress xmin %" PRIu64,
+											   curr_xmin,
 											   (unsigned) ctx.offnum,
-											   (unsigned long long) next_xmin));
+											   next_xmin));
 				else if (xmin_commit_status[nextoffnum] == XID_COMMITTED)
 					report_corruption(&ctx,
-									  psprintf("tuple with aborted xmin %llu was updated to produce a tuple at offset %u with committed xmin %llu",
-											   (unsigned long long) curr_xmin,
+									  psprintf("tuple with aborted xmin %" PRIu64 " was updated to produce a tuple at offset %u with committed xmin %" PRIu64,
+											   curr_xmin,
 											   (unsigned) ctx.offnum,
-											   (unsigned long long) next_xmin));
+											   next_xmin));
 			}
 		}
 
@@ -1147,21 +1147,21 @@ check_tuple_visibility(HeapCheckContext *ctx, bool *xmin_commit_status_ok,
 			break;
 		case XID_IN_FUTURE:
 			report_corruption(ctx,
-							  psprintf("xmin %llu equals or exceeds next valid transaction ID %llu",
-									   (unsigned long long) xmin,
-									   (unsigned long long) XidFromFullTransactionId(ctx->next_fxid)));
+							  psprintf("xmin %" PRIu64 " equals or exceeds next valid transaction ID %" PRIu64,
+									   xmin,
+									   XidFromFullTransactionId(ctx->next_fxid)));
 			return false;
 		case XID_PRECEDES_CLUSTERMIN:
 			report_corruption(ctx,
-							  psprintf("xmin %llu precedes oldest valid transaction ID %llu",
-									   (unsigned long long) xmin,
-									   (unsigned long long) XidFromFullTransactionId(ctx->oldest_fxid)));
+							  psprintf("xmin %" PRIu64 " precedes oldest valid transaction ID %" PRIu64,
+									   xmin,
+									   XidFromFullTransactionId(ctx->oldest_fxid)));
 			return false;
 		case XID_PRECEDES_RELMIN:
 			report_corruption(ctx,
-							  psprintf("xmin %llu precedes relation freeze threshold %llu",
-									   (unsigned long long) xmin,
-									   (unsigned long long) XidFromFullTransactionId(ctx->relfrozenfxid)));
+							  psprintf("xmin %" PRIu64 " precedes relation freeze threshold %" PRIu64,
+									   xmin,
+									   XidFromFullTransactionId(ctx->relfrozenfxid)));
 			return false;
 	}
 
@@ -1185,21 +1185,21 @@ check_tuple_visibility(HeapCheckContext *ctx, bool *xmin_commit_status_ok,
 					return false;
 				case XID_IN_FUTURE:
 					report_corruption(ctx,
-									  psprintf("old-style VACUUM FULL transaction ID %llu for moved off tuple equals or exceeds next valid transaction ID %llu",
-											   (unsigned long long) xvac,
-											   (unsigned long long) XidFromFullTransactionId(ctx->next_fxid)));
+									  psprintf("old-style VACUUM FULL transaction ID %" PRIu64 " for moved off tuple equals or exceeds next valid transaction ID %" PRIu64,
+											   xvac,
+											   XidFromFullTransactionId(ctx->next_fxid)));
 					return false;
 				case XID_PRECEDES_RELMIN:
 					report_corruption(ctx,
-									  psprintf("old-style VACUUM FULL transaction ID %llu for moved off tuple precedes relation freeze threshold %llu",
-											   (unsigned long long) xvac,
-											   (unsigned long long) XidFromFullTransactionId(ctx->relfrozenfxid)));
+									  psprintf("old-style VACUUM FULL transaction ID %" PRIu64 " for moved off tuple precedes relation freeze threshold %" PRIu64,
+											   xvac,
+											   XidFromFullTransactionId(ctx->relfrozenfxid)));
 					return false;
 				case XID_PRECEDES_CLUSTERMIN:
 					report_corruption(ctx,
-									  psprintf("old-style VACUUM FULL transaction ID %llu for moved off tuple precedes oldest valid transaction ID %llu",
-											   (unsigned long long) xvac,
-											   (unsigned long long) XidFromFullTransactionId(ctx->oldest_fxid)));
+									  psprintf("old-style VACUUM FULL transaction ID %" PRIu64 " for moved off tuple precedes oldest valid transaction ID %" PRIu64,
+											   xvac,
+											   XidFromFullTransactionId(ctx->oldest_fxid)));
 					return false;
 				case XID_BOUNDS_OK:
 					break;
@@ -1209,13 +1209,13 @@ check_tuple_visibility(HeapCheckContext *ctx, bool *xmin_commit_status_ok,
 			{
 				case XID_IS_CURRENT_XID:
 					report_corruption(ctx,
-									  psprintf("old-style VACUUM FULL transaction ID %llu for moved off tuple matches our current transaction ID",
-											   (unsigned long long) xvac));
+									  psprintf("old-style VACUUM FULL transaction ID %" PRIu64 " for moved off tuple matches our current transaction ID",
+											   xvac));
 					return false;
 				case XID_IN_PROGRESS:
 					report_corruption(ctx,
-									  psprintf("old-style VACUUM FULL transaction ID %llu for moved off tuple appears to be in progress",
-											   (unsigned long long) xvac));
+									  psprintf("old-style VACUUM FULL transaction ID %" PRIu64 " for moved off tuple appears to be in progress",
+											   xvac));
 					return false;
 
 				case XID_COMMITTED:
@@ -1251,21 +1251,21 @@ check_tuple_visibility(HeapCheckContext *ctx, bool *xmin_commit_status_ok,
 					return false;
 				case XID_IN_FUTURE:
 					report_corruption(ctx,
-									  psprintf("old-style VACUUM FULL transaction ID %llu for moved in tuple equals or exceeds next valid transaction ID %llu",
-											   (unsigned long long) xvac,
-											   (unsigned long long) XidFromFullTransactionId(ctx->next_fxid)));
+									  psprintf("old-style VACUUM FULL transaction ID %" PRIu64 " for moved in tuple equals or exceeds next valid transaction ID %" PRIu64,
+											   xvac,
+											   XidFromFullTransactionId(ctx->next_fxid)));
 					return false;
 				case XID_PRECEDES_RELMIN:
 					report_corruption(ctx,
-									  psprintf("old-style VACUUM FULL transaction ID %llu for moved in tuple precedes relation freeze threshold %llu",
-											   (unsigned long long) xvac,
-											   (unsigned long long) XidFromFullTransactionId(ctx->relfrozenfxid)));
+									  psprintf("old-style VACUUM FULL transaction ID %" PRIu64 " for moved in tuple precedes relation freeze threshold %" PRIu64,
+											   xvac,
+											   XidFromFullTransactionId(ctx->relfrozenfxid)));
 					return false;
 				case XID_PRECEDES_CLUSTERMIN:
 					report_corruption(ctx,
-									  psprintf("old-style VACUUM FULL transaction ID %llu for moved in tuple precedes oldest valid transaction ID %llu",
-											   (unsigned long long) xvac,
-											   (unsigned long long) XidFromFullTransactionId(ctx->oldest_fxid)));
+									  psprintf("old-style VACUUM FULL transaction ID %" PRIu64 " for moved in tuple precedes oldest valid transaction ID %" PRIu64,
+											   xvac,
+											   XidFromFullTransactionId(ctx->oldest_fxid)));
 					return false;
 				case XID_BOUNDS_OK:
 					break;
@@ -1275,13 +1275,13 @@ check_tuple_visibility(HeapCheckContext *ctx, bool *xmin_commit_status_ok,
 			{
 				case XID_IS_CURRENT_XID:
 					report_corruption(ctx,
-									  psprintf("old-style VACUUM FULL transaction ID %llu for moved in tuple matches our current transaction ID",
-											   (unsigned long long) xvac));
+									  psprintf("old-style VACUUM FULL transaction ID %" PRIu64 " for moved in tuple matches our current transaction ID",
+											   xvac));
 					return false;
 				case XID_IN_PROGRESS:
 					report_corruption(ctx,
-									  psprintf("old-style VACUUM FULL transaction ID %llu for moved in tuple appears to be in progress",
-											   (unsigned long long) xvac));
+									  psprintf("old-style VACUUM FULL transaction ID %" PRIu64 " for moved in tuple appears to be in progress",
+											   xvac));
 					return false;
 
 				case XID_COMMITTED:
@@ -1351,21 +1351,18 @@ check_tuple_visibility(HeapCheckContext *ctx, bool *xmin_commit_status_ok,
 				return true;
 			case XID_PRECEDES_RELMIN:
 				report_corruption(ctx,
-								  psprintf("multitransaction ID %llu precedes relation minimum multitransaction ID threshold %llu",
-										   (unsigned long long) xmax,
-										   (unsigned long long) ctx->relminmxid));
+								  psprintf("multitransaction ID %" PRIu64 " precedes relation minimum multitransaction ID threshold %" PRIu64,
+										   xmax, ctx->relminmxid));
 				return true;
 			case XID_PRECEDES_CLUSTERMIN:
 				report_corruption(ctx,
-								  psprintf("multitransaction ID %llu precedes oldest valid multitransaction ID threshold %llu",
-										   (unsigned long long) xmax,
-										   (unsigned long long) ctx->oldest_mxact));
+								  psprintf("multitransaction ID %" PRIu64 " precedes oldest valid multitransaction ID threshold %" PRIu64,
+										   xmax, ctx->oldest_mxact));
 				return true;
 			case XID_IN_FUTURE:
 				report_corruption(ctx,
-								  psprintf("multitransaction ID %llu equals or exceeds next valid multitransaction ID %llu",
-										   (unsigned long long) xmax,
-										   (unsigned long long) ctx->next_mxact));
+								  psprintf("multitransaction ID %" PRIu64 " equals or exceeds next valid multitransaction ID %" PRIu64,
+										   xmax, ctx->next_mxact));
 				return true;
 			case XID_BOUNDS_OK:
 				break;
@@ -1411,21 +1408,21 @@ check_tuple_visibility(HeapCheckContext *ctx, bool *xmin_commit_status_ok,
 				return true;
 			case XID_IN_FUTURE:
 				report_corruption(ctx,
-								  psprintf("update xid %llu equals or exceeds next valid transaction ID %llu",
-										   (unsigned long long) xmax,
-										   (unsigned long long) XidFromFullTransactionId(ctx->next_fxid)));
+								  psprintf("update xid %" PRIu64 " equals or exceeds next valid transaction ID %" PRIu64,
+										   xmax,
+										   XidFromFullTransactionId(ctx->next_fxid)));
 				return true;
 			case XID_PRECEDES_RELMIN:
 				report_corruption(ctx,
-								  psprintf("update xid %llu precedes relation freeze threshold %llu",
-										   (unsigned long long) xmax,
-										   (unsigned long long) XidFromFullTransactionId(ctx->relfrozenfxid)));
+								  psprintf("update xid %" PRIu64 " precedes relation freeze threshold %" PRIu64,
+										   xmax,
+										   XidFromFullTransactionId(ctx->relfrozenfxid)));
 				return true;
 			case XID_PRECEDES_CLUSTERMIN:
 				report_corruption(ctx,
-								  psprintf("update xid %llu precedes oldest valid transaction ID %llu",
-										   (unsigned long long) xmax,
-										   (unsigned long long) XidFromFullTransactionId(ctx->oldest_fxid)));
+								  psprintf("update xid %" PRIu64 " precedes oldest valid transaction ID %" PRIu64,
+										   xmax,
+										   XidFromFullTransactionId(ctx->oldest_fxid)));
 				return true;
 			case XID_BOUNDS_OK:
 				break;
@@ -1473,21 +1470,20 @@ check_tuple_visibility(HeapCheckContext *ctx, bool *xmin_commit_status_ok,
 			return true;
 		case XID_IN_FUTURE:
 			report_corruption(ctx,
-							  psprintf("xmax %llu equals or exceeds next valid transaction ID %llu",
-									   (unsigned long long) xmax,
-									   (unsigned long long) XidFromFullTransactionId(ctx->next_fxid)));
+							  psprintf("xmax %" PRIu64 " equals or exceeds next valid transaction ID %" PRIu64,
+									   xmax, XidFromFullTransactionId(ctx->next_fxid)));
 			return false;		/* corrupt */
 		case XID_PRECEDES_RELMIN:
 			report_corruption(ctx,
-							  psprintf("xmax %llu precedes relation freeze threshold %llu",
-									   (unsigned long long) xmax,
-									   (unsigned long long) XidFromFullTransactionId(ctx->relfrozenfxid)));
+							  psprintf("xmax %" PRIu64 " precedes relation freeze threshold %" PRIu64,
+									   xmax,
+									   XidFromFullTransactionId(ctx->relfrozenfxid)));
 			return false;		/* corrupt */
 		case XID_PRECEDES_CLUSTERMIN:
 			report_corruption(ctx,
-							  psprintf("xmax %llu precedes oldest valid transaction ID %llu",
-									   (unsigned long long) xmax,
-									   (unsigned long long) XidFromFullTransactionId(ctx->oldest_fxid)));
+							  psprintf("xmax %" PRIu64 " precedes oldest valid transaction ID %" PRIu64,
+									   xmax,
+									   XidFromFullTransactionId(ctx->oldest_fxid)));
 			return false;		/* corrupt */
 		case XID_BOUNDS_OK:
 			break;
diff --git a/contrib/pageinspect/btreefuncs.c b/contrib/pageinspect/btreefuncs.c
index 091bbdb901..e9212c7fa1 100644
--- a/contrib/pageinspect/btreefuncs.c
+++ b/contrib/pageinspect/btreefuncs.c
@@ -145,8 +145,8 @@ GetBTPageStatistics(BlockNumber blkno, Buffer buffer, BTPageStat *stat)
 		{
 			FullTransactionId safexid = BTPageGetDeleteXid(page);
 
-			elog(DEBUG2, "deleted page from block %u has safexid %llu",
-				 blkno, (unsigned long long) XidFromFullTransactionId(safexid));
+			elog(DEBUG2, "deleted page from block %u has safexid %" PRIu64,
+				 blkno, XidFromFullTransactionId(safexid));
 		}
 		else
 		{
diff --git a/contrib/pg_overexplain/pg_overexplain.c b/contrib/pg_overexplain/pg_overexplain.c
index 4f51ceb24a..98a4bc7a4d 100644
--- a/contrib/pg_overexplain/pg_overexplain.c
+++ b/contrib/pg_overexplain/pg_overexplain.c
@@ -759,7 +759,7 @@ overexplain_intlist(const char *qlabel, List *list, ExplainState *es)
 	else if (IsA(list, XidList))
 	{
 		foreach_xid(x, list)
-			appendStringInfo(&buf, " %llu", (unsigned long long) x);
+			appendStringInfo(&buf, " %" PRIu64, x);
 	}
 	else
 	{
diff --git a/contrib/pgrowlocks/pgrowlocks.c b/contrib/pgrowlocks/pgrowlocks.c
index 323668900c..fbc6f7fbbd 100644
--- a/contrib/pgrowlocks/pgrowlocks.c
+++ b/contrib/pgrowlocks/pgrowlocks.c
@@ -145,8 +145,7 @@ pgrowlocks(PG_FUNCTION_ARGS)
 															 PointerGetDatum(&tuple->t_self));
 
 			values[Atnum_xmax] = palloc(NCHARS * sizeof(char));
-			snprintf(values[Atnum_xmax], NCHARS, "%llu",
-					 (unsigned long long) xmax);
+			snprintf(values[Atnum_xmax], NCHARS, "%" PRIu64, xmax);
 			if (infomask & HEAP_XMAX_IS_MULTI)
 			{
 				MultiXactMember *members;
@@ -187,8 +186,7 @@ pgrowlocks(PG_FUNCTION_ARGS)
 							strcat(values[Atnum_modes], ",");
 							strcat(values[Atnum_pids], ",");
 						}
-						snprintf(buf, NCHARS, "%llu",
-								 (unsigned long long) members[j].xid);
+						snprintf(buf, NCHARS, "%" PRIu64, members[j].xid);
 						strcat(values[Atnum_xids], buf);
 						switch (members[j].status)
 						{
@@ -229,8 +227,7 @@ pgrowlocks(PG_FUNCTION_ARGS)
 				values[Atnum_ismulti] = pstrdup("false");
 
 				values[Atnum_xids] = palloc(NCHARS * sizeof(char));
-				snprintf(values[Atnum_xids], NCHARS, "{%llu}",
-						 (unsigned long long) xmax);
+				snprintf(values[Atnum_xids], NCHARS, "{%" PRIu64 "}", xmax);
 
 				values[Atnum_modes] = palloc(NCHARS);
 				if (infomask & HEAP_XMAX_LOCK_ONLY)
diff --git a/contrib/test_decoding/test_decoding.c b/contrib/test_decoding/test_decoding.c
index 19a7392d4d..f5f804b68c 100644
--- a/contrib/test_decoding/test_decoding.c
+++ b/contrib/test_decoding/test_decoding.c
@@ -311,7 +311,7 @@ pg_output_begin(LogicalDecodingContext *ctx, TestDecodingData *data, ReorderBuff
 {
 	OutputPluginPrepareWrite(ctx, last_write);
 	if (data->include_xids)
-		appendStringInfo(ctx->out, "BEGIN %llu", (unsigned long long) txn->xid);
+		appendStringInfo(ctx->out, "BEGIN %" PRIu64, txn->xid);
 	else
 		appendStringInfoString(ctx->out, "BEGIN");
 	OutputPluginWrite(ctx, last_write);
@@ -334,7 +334,7 @@ pg_decode_commit_txn(LogicalDecodingContext *ctx, ReorderBufferTXN *txn,
 
 	OutputPluginPrepareWrite(ctx, true);
 	if (data->include_xids)
-		appendStringInfo(ctx->out, "COMMIT %llu", (unsigned long long) txn->xid);
+		appendStringInfo(ctx->out, "COMMIT %" PRIu64, txn->xid);
 	else
 		appendStringInfoString(ctx->out, "COMMIT");
 
@@ -387,7 +387,7 @@ pg_decode_prepare_txn(LogicalDecodingContext *ctx, ReorderBufferTXN *txn,
 					 quote_literal_cstr(txn->gid));
 
 	if (data->include_xids)
-		appendStringInfo(ctx->out, ", txid %llu", (unsigned long long) txn->xid);
+		appendStringInfo(ctx->out, ", txid %" PRIu64, txn->xid);
 
 	if (data->include_timestamp)
 		appendStringInfo(ctx->out, " (at %s)",
@@ -409,7 +409,7 @@ pg_decode_commit_prepared_txn(LogicalDecodingContext *ctx, ReorderBufferTXN *txn
 					 quote_literal_cstr(txn->gid));
 
 	if (data->include_xids)
-		appendStringInfo(ctx->out, ", txid %llu", (unsigned long long) txn->xid);
+		appendStringInfo(ctx->out, ", txid %" PRIu64, txn->xid);
 
 	if (data->include_timestamp)
 		appendStringInfo(ctx->out, " (at %s)",
@@ -433,7 +433,7 @@ pg_decode_rollback_prepared_txn(LogicalDecodingContext *ctx,
 					 quote_literal_cstr(txn->gid));
 
 	if (data->include_xids)
-		appendStringInfo(ctx->out, ", txid %llu", (unsigned long long) txn->xid);
+		appendStringInfo(ctx->out, ", txid %" PRIu64, txn->xid);
 
 	if (data->include_timestamp)
 		appendStringInfo(ctx->out, " (at %s)",
@@ -795,8 +795,8 @@ pg_output_stream_start(LogicalDecodingContext *ctx, TestDecodingData *data, Reor
 	OutputPluginPrepareWrite(ctx, last_write);
 	if (data->include_xids)
 		appendStringInfo(ctx->out,
-						 "opening a streamed block for transaction TXN %llu",
-						 (unsigned long long) txn->xid);
+						 "opening a streamed block for transaction TXN %" PRIu64,
+						 txn->xid);
 	else
 		appendStringInfoString(ctx->out, "opening a streamed block for transaction");
 	OutputPluginWrite(ctx, last_write);
@@ -815,8 +815,8 @@ pg_decode_stream_stop(LogicalDecodingContext *ctx,
 	OutputPluginPrepareWrite(ctx, true);
 	if (data->include_xids)
 		appendStringInfo(ctx->out,
-						 "closing a streamed block for transaction TXN %llu",
-						 (unsigned long long) txn->xid);
+						 "closing a streamed block for transaction TXN %" PRIu64,
+						 txn->xid);
 	else
 		appendStringInfoString(ctx->out, "closing a streamed block for transaction");
 	OutputPluginWrite(ctx, true);
@@ -851,8 +851,8 @@ pg_decode_stream_abort(LogicalDecodingContext *ctx,
 	OutputPluginPrepareWrite(ctx, true);
 	if (data->include_xids)
 		appendStringInfo(ctx->out,
-						 "aborting streamed (sub)transaction TXN %llu",
-						 (unsigned long long) txn->xid);
+						 "aborting streamed (sub)transaction TXN %" PRIu64,
+						 txn->xid);
 	else
 		appendStringInfoString(ctx->out, "aborting streamed (sub)transaction");
 	OutputPluginWrite(ctx, true);
@@ -873,9 +873,9 @@ pg_decode_stream_prepare(LogicalDecodingContext *ctx,
 
 	if (data->include_xids)
 		appendStringInfo(ctx->out,
-						 "preparing streamed transaction TXN %s, txid %llu",
+						 "preparing streamed transaction TXN %s, txid %" PRIu64,
 						 quote_literal_cstr(txn->gid),
-						 (unsigned long long) txn->xid);
+						 txn->xid);
 	else
 		appendStringInfo(ctx->out, "preparing streamed transaction %s",
 						 quote_literal_cstr(txn->gid));
@@ -906,8 +906,8 @@ pg_decode_stream_commit(LogicalDecodingContext *ctx,
 
 	if (data->include_xids)
 		appendStringInfo(ctx->out,
-						 "committing streamed transaction TXN %llu",
-						 (unsigned long long) txn->xid);
+						 "committing streamed transaction TXN %" PRIu64,
+						 txn->xid);
 	else
 		appendStringInfoString(ctx->out, "committing streamed transaction");
 
@@ -941,8 +941,8 @@ pg_decode_stream_change(LogicalDecodingContext *ctx,
 
 	OutputPluginPrepareWrite(ctx, true);
 	if (data->include_xids)
-		appendStringInfo(ctx->out, "streaming change for TXN %llu",
-						 (unsigned long long) txn->xid);
+		appendStringInfo(ctx->out, "streaming change for TXN %" PRIu64,
+						 txn->xid);
 	else
 		appendStringInfoString(ctx->out, "streaming change for transaction");
 	OutputPluginWrite(ctx, true);
@@ -1008,8 +1008,8 @@ pg_decode_stream_truncate(LogicalDecodingContext *ctx, ReorderBufferTXN *txn,
 
 	OutputPluginPrepareWrite(ctx, true);
 	if (data->include_xids)
-		appendStringInfo(ctx->out, "streaming truncate for TXN %llu",
-						 (unsigned long long) txn->xid);
+		appendStringInfo(ctx->out, "streaming truncate for TXN %" PRIu64,
+						 txn->xid);
 	else
 		appendStringInfoString(ctx->out, "streaming truncate for transaction");
 	OutputPluginWrite(ctx, true);
diff --git a/doc/src/sgml/logicaldecoding.sgml b/doc/src/sgml/logicaldecoding.sgml
index 64b736a26d..d97fe52ffd 100644
--- a/doc/src/sgml/logicaldecoding.sgml
+++ b/doc/src/sgml/logicaldecoding.sgml
@@ -1212,7 +1212,7 @@ typedef void (*LogicalDecodeStreamTruncateCB) (struct LogicalDecodingContext *ct
      output plugin:
 <programlisting>
 OutputPluginPrepareWrite(ctx, true);
-appendStringInfo(ctx->out, "BEGIN %llu", (unsigned long long) txn->xid);
+appendStringInfo(ctx->out, "BEGIN %" PRIu64, txn->xid);
 OutputPluginWrite(ctx, true);
 </programlisting>
     </para>
diff --git a/src/backend/access/common/reloptions.c b/src/backend/access/common/reloptions.c
index c56ea7590d..310bcdc60d 100644
--- a/src/backend/access/common/reloptions.c
+++ b/src/backend/access/common/reloptions.c
@@ -1697,10 +1697,9 @@ parse_one_reloption(relopt_value *option, char *text_str, int text_len,
 							(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
 							 errmsg("value %s out of bounds for option \"%s\"",
 									value, option->gen->name),
-							 errdetail("Valid values are between \"%lld"
-									   "\" and \"%lld\".",
-									   (long long ) optint->min,
-									   (long long) optint->max)));
+							 errdetail("Valid values are between \"%" PRId64
+									   "\" and \"%" PRId64 "\".",
+									   optint->min, optint->max)));
 			}
 			break;
 		case RELOPT_TYPE_REAL:
